re = {}
aa=1
mission = 0
latitude = 0.0000
longitude = 0.0000
BatterySensor = "RxBt"
senCurr = "Curr"
senCapa = "Capa"
senBatPerc = "Bat%"
sen1RSS = "1RSS"
sen2RSS = "2RSS"
senRQly = "RQly"
senRSNR = "RSNR"
senANT = "ANT"
senANT = "RFMD"
senTPWR = "TPWR"
senTRSS = "TRSS"
senTQly = "TQly"
senTSNR = "TSNR"
senPtch = "Ptch"
senRoll = "Roll"
senYaw = "Yaw"
senVSpd = "VSpd"
senAltB = "Alt"
senGPS= "GPS"
senGSpd = "GSpd"
senHdg = "Hdg"
senAlt = "Alt"
senSats = "Sats"

ReceiverBatteryVoltage_current = 0.0
ReceiverBatteryVoltage_previous = 0.0
ReceiverBatteryVoltage_startup = 0.0
sensorAlt = 0.0
sensorSpd = 0.0
sensorSats = 0
sensorCurr = 0
sensorWP = 0.0
sensorGRP = 0.0
sensorHeading = 0
sensorCapa = 0
sensorMode = 0.0
sensorRema = 0
chThr = 0

local GREY = GREY_DEFAULT or GREY or 0


function init_uni()
    my_gpsId  = getFieldInfo("GPS") and getFieldInfo("GPS").id or nil;
end

function round(n, p)
    p = 10^(p or 0)
    if n >= 0 then
        return math.floor(n * p + 0.5) / p
    else
        return math.ceil(n * p - 0.5) / p
    end
end

function updatesens()
  ReceiverBatteryVoltage_previous = ReceiverBatteryVoltage_current
  ReceiverBatteryVoltage_current = getValue(BatterySensor)
  sensorAlt = getValue(senAlt)
  sensorMaxAlt = getValue(senPtch)
  sensorSpd = getValue(senGSpd)
  sensorSats = getValue(senSats)
  sensorCurr = getValue(senCurr)
  sensorWP = getValue(senRoll) 
  sensorGRP = getValue(senYaw) 
  sensorHeading = getValue(senHdg) 
  sensorCapa = getValue(senCapa)
  sensorRema = getValue(senBatPerc)
  sensorMode = getValue(senVSpd)
  chThr = getValue("thr")
  --unitelem(sensorCapa)
end


prevGps = -1
function soundProcessing()
  if prevGps > sensorSats then
    
  end
  prevGps = sensorSats
end

function mapval(x, in_min, in_max, out_min, out_max)
	return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min
end

function drawArrow(xPos,yPos,angle,size)
  local radius=size/2-2
  local spX = xPos + (radius*math.cos(angle))
  local spY = yPos - (radius*math.sin(angle))
  local epX = xPos - (radius*math.cos(angle))
  local epY = yPos + (radius*math.sin(angle))
  lcd.drawRectangle(xPos-size/2,yPos-size/2,size,size)
  lcd.drawLine(spX,spY,epX,epY,SOLID,FORCE)
  lcd.drawFilledRectangle(spX-1,spY-1,3,3,SOLID)
end


function welcome_screen() 
  x = 1
  y = 1
  stp = 14
  lcd.clear()
  lcd.drawText (x,y, "Uniboat autopilot")
  lcd.drawText (x,y+stp, "+7-999-395-3502")
  lcd.drawText (x,y+stp*2, "www.uniboat.ru")
end

function unichcalc(re, chname, v, chmin, stp, startnum, endnum) 
   local mi = chmin * stp
   local fmin = mi + startnum*stp
   local fmax = mi + (endnum)*stp
   if v >= fmin  and v<fmax  then 
     re[chname] = (v-fmin)/stp;  
   end
end



function unitelem(re, v, mi,stp) 
   unichcalc(re, "sats", v, mi, stp, 0, 59)
   unichcalc(re, "mode", v, mi, stp, 60 ,69)
   unichcalc(re, "crsc", v, mi, stp, 70 ,79)
   unichcalc(re, "WP", v, mi, stp, 100 ,199)
   unichcalc(re, "GRP", v, mi, stp, 200 ,299)
   unichcalc(re, "menu", v, mi, stp, 300 ,399)
   unichcalc(re, "cursor", v, mi, stp, 400 ,499)
   unichcalc(re, "temp1", v, mi, stp, 600 ,799)
   unichcalc(re, "temp2", v, mi, stp, 800 ,899)
   unichcalc(re, "dist", v, mi, stp, 1000 ,3000)
end


lastplayid = -1
lastplaytime = 0
function uniplay(id) 
  if not id or id<=0 or lastplayid==id then return end
  lastplaytime = getTime()
  if id==1 then playFile("/SCRIPTS/UNIBOAT/WAV/uni.wav") end
  if id==20 then playFile("/SCRIPTS/UNIBOAT/WAV/alertcurrmot.wav") end
  if id==21 then playFile("/SCRIPTS/UNIBOAT/WAV/alertdeep.wav") end
  if id==22 then playFile("/SCRIPTS/UNIBOAT/WAV/alertsat1.wav") end
  if id==23 then playFile("/SCRIPTS/UNIBOAT/WAV/alertstop.wav") end
  if id==24 then playFile("/SCRIPTS/UNIBOAT/WAV/batchange.wav") end
  if id==25 then playFile("/SCRIPTS/UNIBOAT/WAV/bun1on.wav") end
  if id==26 then playFile("/SCRIPTS/UNIBOAT/WAV/bun2on.wav") end
  if id==27 then playFile("/SCRIPTS/UNIBOAT/WAV/bun3on.wav") end
  if id==28 then playFile("/SCRIPTS/UNIBOAT/WAV/bun4on.wav") end
  if id==29 then playFile("/SCRIPTS/UNIBOAT/WAV/bunon.wav") end
  if id==30 then playFile("/SCRIPTS/UNIBOAT/WAV/calibrate.wav") end
  if id==31 then playFile("/SCRIPTS/UNIBOAT/WAV/camoff.wav") end
  if id==32 then playFile("/SCRIPTS/UNIBOAT/WAV/camon.wav") end
  if id==33 then playFile("/SCRIPTS/UNIBOAT/WAV/curralert.wav") end
  if id==34 then playFile("/SCRIPTS/UNIBOAT/WAV/fish1.wav") end
  if id==35 then playFile("/SCRIPTS/UNIBOAT/WAV/fish2.wav") end
  if id==36 then playFile("/SCRIPTS/UNIBOAT/WAV/fish3.wav") end
  if id==37 then playFile("/SCRIPTS/UNIBOAT/WAV/gohome.wav") end
  if id==38 then playFile("/SCRIPTS/UNIBOAT/WAV/gopath.wav") end
  if id==39 then playFile("/SCRIPTS/UNIBOAT/WAV/gowp.wav") end
  if id==40 then playFile("/SCRIPTS/UNIBOAT/WAV/gowp1.wav") end
  if id==41 then playFile("/SCRIPTS/UNIBOAT/WAV/mesto.wav") end
  if id==42 then playFile("/SCRIPTS/UNIBOAT/WAV/mode_easy.wav") end
  if id==43 then playFile("/SCRIPTS/UNIBOAT/WAV/mode_hard.wav") end
  if id==44 then playFile("/SCRIPTS/UNIBOAT/WAV/mode_man.wav") end
  if id==45 then playFile("/SCRIPTS/UNIBOAT/WAV/mode_marsh.wav") end
  if id==46 then playFile("/SCRIPTS/UNIBOAT/WAV/pirat.wav") end
  if id==47 then playFile("/SCRIPTS/UNIBOAT/WAV/point.wav") end
  if id==48 then playFile("/SCRIPTS/UNIBOAT/WAV/razbron.wav") end
  if id==48 then playFile("/SCRIPTS/UNIBOAT/WAV/rebooting.wav") end
  if id==50 then playFile("/SCRIPTS/UNIBOAT/WAV/relefper.wav") end
  if id==51 then playFile("/SCRIPTS/UNIBOAT/WAV/retboss.wav") end
  if id==52 then playFile("/SCRIPTS/UNIBOAT/WAV/rezpit.wav") end
  if id==53 then playFile("/SCRIPTS/UNIBOAT/WAV/sathren.wav") end
  if id==54 then playFile("/SCRIPTS/UNIBOAT/WAV/scanstart.wav") end
  if id==55 then playFile("/SCRIPTS/UNIBOAT/WAV/sonarfound.wav") end
  if id==56 then playFile("/SCRIPTS/UNIBOAT/WAV/thankUni.wav") end
  if id==57 then playFile("/SCRIPTS/UNIBOAT/WAV/uni.wav") end
  if id==58 then playFile("/SCRIPTS/UNIBOAT/WAV/uni1.wav") end
  if id==59 then playFile("/SCRIPTS/UNIBOAT/WAV/update.wav") end
  if id==60 then playFile("/SCRIPTS/UNIBOAT/WAV/warnwater.wav") end
  lastplayid = id
end