local zone, options = ...
local VERSION = "2.2.4"
local FILE_PATH = "/SCRIPTS/TELEMETRY/iNav/"
local SMLCD = LCD_W < 212
local HORUS = LCD_W >= 480 or LCD_H >= 480
local tmp, view, lang, playLog
local env = "bt" -- compile on platform
local inav = {}

local ext = "" -- compile on platform

local v, r, m, i, e, osname = getVersion()


dofile("/SCRIPTS/FUNCTIONS/unilib.lua") 
dofile("/SCRIPTS/GRAPHS/graphs.lua") 
trgrs = assert(loadScript("/SCRIPTS/GRAPHS/trigger.lua"))()

local ReceiverBatteryVoltage_startup = 0.0

local x = 0
local y = 0
local fh = 10
local my_gpsId
local perc=0
local nplay = 0
local prevWp=-1
local curWp=-2


local function soundProcessing() 
  
  if re["WP"] then 
    curWp = re["WP"]
    if prevWp~=curWp then 
      uniplay(47) 
      playNumber(curWp,0,5)
      prevWp=curWp 
    end  
  end  
end  


local function init_func()
  --init_uni()
  my_gpsId  = getFieldInfo("GPS") and getFieldInfo("GPS").id or nil;
  ReceiverBatteryVoltage_startup = getValue(BatterySensor)
  ReceiverBatteryVoltage_startup = getValue(BatterySensor)
  setSerialBaudrate(115200)
  soundProcessing() 
end

local function sendAux(str) 
  serialWrite(str)
end

local function sendAuxCR(str) 
  serialWrite(str..'\n')
end


local function bg_func()
  updatesens()
  uniplay(re["play"])
  
  
  if my_gpsId then
  local gpsid = getValue(my_gpsId)
  end
  
	if gpsid and gpsid~= 0 then
		local gps = getValue(my_gpsId)
    if gps then
		latitude, longitude = gps.lat, gps.lon
    end
    
    sendAuxCR('Latitude: '..latitude)
    sendAuxCR('Longitude: '..longitude)
    sendAuxCR('Altitude: '..getValue('Alt'))
    sendAuxCR('Ground speed: '..getValue('GSPd'))
    sendAuxCR('Heading: '..getValue('Hdg'))    
    
	end	  
  
  local ca = getValue("Capa")
  if ca then
    unitelem(re, ca, -3276, 2560)
  end

  if ReceiverBatteryVoltage_startup == 0 then
    ReceiverBatteryVoltage_startup = getValue(BatterySensor)
  end
  ReceiverBatteryVoltage_previous = ReceiverBatteryVoltage_current
  ReceiverBatteryVoltage_current = getValue(BatterySensor)
  sensorAlt = getValue(senAlt)
  sensorMaxAlt = getValue(senPtch)
  sensorSpd = getValue(senGSpd)
  sensorSats = getValue(senSats)
  sensorCurr = getValue(senCurr)
  sensorWP = getValue(senRoll) 
  sensorGRP = getValue(senYaw) 
  sensorHeading = getValue(senHdg) 
  sensorMode = getValue(senVSpd)
end

local function drawRSSI(x, y, w, h)
   
    local rssi = getRSSI()
    if rssi and perc then
    if rssi > 38 then
        perc = round(perc * 0.5 + 0.5 * (((math.log(rssi - 28, 10) - 1) / (math.log(72, 10) - 1)) * 100))
	      if perc > 100 then perc = 100 end
    else
	      perc = 0
    end
    --lcd.drawText(x, y, perc .. '%', SMLSIZE + INVERS)
    --lcd.drawText(x, y+8, rssi .. 'dB', SMLSIZE + INVERS)
    lcd.drawFilledRectangle(x, y, w, h,SOLID)    
    lcd.drawFilledRectangle(x, y, w, h - perc/10 * h/10,WHITE)    
    lcd.drawRectangle(x, y, w, h, SOLID)    
    end
end

local function drawboat(x,y,w,h,nbun) 
  local leftk = x + w/4
  local ycenter = y+h/2
    lcd.drawRectangle(x + w/4, y, w - w/4, h, 1)
    lcd.drawLine(x, ycenter, leftk, y+1, SOLID,1,1)
    lcd.drawLine(x, ycenter, leftk, y+h-1, SOLID,1,1)
    
   -- lcd.drawCircle(leftk,ycenter,12, BLACK)
    
end

local function header1() 
   lcd.drawPixmap(41, 0, "/SCRIPTS/BMP/vbat.bmp",1)
   lcd.drawNumber(55, 1,  ReceiverBatteryVoltage_current *10, PREC1)
   lcd.drawPixmap(75, 0, "/SCRIPTS/BMP/curr.bmp",1)
   lcd.drawNumber(88, 1,  sensorCurr *10, PREC1)
   
   lcd.drawPixmap(103, 1, "/SCRIPTS/BMP/sats.bmp")
   if sensorSats > 0 then
    lcd.drawNumber(119, 1,  sensorSats)
   else 
    lcd.drawText(119, 1,  "-",BLINK)
   end
   lcd.drawLine(0, 9, LCD_W, 9, SOLID,1,1)
end

local function footer() 
   --lcd.drawLine(0, 52, LCD_W, 52, SOLID,1,1)

  lcd.drawPixmap(1, 55, "/SCRIPTS/BMP/speed.bmp",1)
  lcd.drawNumber(31, 53,  sensorSpd * 10, PREC1+MIDSIZE)
   
  lcd.drawPixmap(58, 55, "/SCRIPTS/BMP/DIST.bmp",1)
   
   
  if re["dist"] then 
    lcd.drawNumber(93, 53, re["dist"]  , MIDSIZE) else  lcd.drawText(93, 53,  "---",BLINK)
  end   
   
end

local function drawBunker(x,y,h,w,name, val) 
  lcd.drawText(x, y, name  , SMLSIZE) 
  lcd.drawFilledRectangle(x, y+7, w, h-8, SOLID)    
end

local function drawBunkers(x,y,h,w,n) 
  local stpb=7
  local stp=x
  for i = 1, n do -- цикл от 1 до 10 с шагом 1
    drawBunker(stp,y,25,5,i, 100) 
    stp=stp+stpb
  end
end

local function manual_screen() 

    model.setGlobalVariable(8, 0, 998)
   drawBunkers(68,24,25,5,8) 
   drawArrow(55,36, math.deg (360-sensorHeading),25)
  
   lcd.drawPixmap(0, 0, "/SCRIPTS/BMP/mode_man.bmp",1)
   header1() 
   
  if re["crsc"] == 1 then 
   lcd.drawPixmap(0, 11, "/SCRIPTS/BMP/crson.bmp",1)
  else 
   lcd.drawPixmap(0, 11, "/SCRIPTS/BMP/crsoff.bmp",1)
  end   
   
   lcd.drawPixmap(22, 12, "/SCRIPTS/BMP/loiter.bmp",1)
  if re["GRP"] then 
     lcd.drawNumber(55, 10,  re["GRP"],MIDSIZE + INVERS) else  lcd.drawText(55, 10,  "??",BLINK+MIDSIZE + INVERS)
     --lcd.drawNumber(x+xVal1, y+stp*6,  sensorGRP)
  end   

   lcd.drawPixmap(72, 11, "/SCRIPTS/BMP/wp.bmp",1)
  if re["WP"] then 
     lcd.drawNumber(90, 10,  re["WP"],MIDSIZE + INVERS) else  lcd.drawText(90, 10,  "??",BLINK+MIDSIZE + INVERS)
     --lcd.drawNumber(x+xVal1, y+stp*6,  sensorGRP)
  end   
  
  if re["temp1"] then 
     lcd.drawNumber(110, 10,  re["temp1"],SMLSIZE ) else  lcd.drawText(110, 10,  "--.-",SMLSIZE)
     --lcd.drawNumber(x+xVal1, y+stp*6,  sensorGRP)
  end   
  if re["temp2"] then 
     lcd.drawNumber(110, 16,  re["temp2"],SMLSIZE ) else  lcd.drawText(110, 16,  "--.-",SMLSIZE)
     --lcd.drawNumber(x+xVal1, y+stp*6,  sensorGRP)
  end   
  
  
  
   lcd.drawLine(0, 22, LCD_W, 22, SOLID,1,1)
   lcd.drawPixmap(0, 25, "/SCRIPTS/BMP/glubina.bmp",1)

   local aaa = 0
   if sensorAlt==0 then aaa=BLINK end
   lcd.drawNumber(1, 35,  sensorAlt,PREC2+MIDSIZE+aaa)

 lcd.drawGauge(0, 48, LCD_W, 5 ,mission, 100)
  
  footer()
  
  --drawboat(1,25,LCD_W-30,25,4) 
  drawRSSI(LCD_W-4, LCD_H-42,5,42)
end

local function path_screen() 


   model.setGlobalVariable(8, 0, 996)
   lcd.drawPixmap(0, 0, "/SCRIPTS/BMP/mode_path.bmp",1)
   header1() 
   
  if re["crsc"] == 1 then 
   lcd.drawPixmap(0, 9, "/SCRIPTS/BMP/crson.bmp",1)
  else 
   lcd.drawPixmap(0, 9, "/SCRIPTS/BMP/crsoff.bmp",1)
  end   
   
   lcd.drawPixmap(22, 10, "/SCRIPTS/BMP/loiter.bmp",1)
  if re["GRP"] then 
     lcd.drawNumber(55, 11,  re["GRP"]) else  lcd.drawText(55, 11,  "???")
     --lcd.drawNumber(x+xVal1, y+stp*6,  sensorGRP)
  end   

footer()
end

local function easy_screen() 
    

   model.setGlobalVariable(8, 0, 1000)
   lcd.drawPixmap(0, 0, "/SCRIPTS/BMP/mode_easy.bmp",1)
   header1() 
   
  if re["crsc"] == 1 then 
   lcd.drawPixmap(0, 9, "/SCRIPTS/BMP/crson.bmp",1)
  else 
   lcd.drawPixmap(0, 9, "/SCRIPTS/BMP/crsoff.bmp",1)
  end   
  
  
   
   lcd.drawPixmap(22, 10, "/SCRIPTS/BMP/loiter.bmp",1)
  if re["GRP"] then 
     lcd.drawNumber(55, 11,  re["GRP"]) else  lcd.drawText(55, 11,  "???")
     --lcd.drawNumber(x+xVal1, y+stp*6,  sensorGRP)
  end   

footer()
end

local function auto_screen() 
 
  lcd.drawPixmap(0, 0, "/SCRIPTS/BMP/mode_man.bmp",1)

  x = 1
  y = 1
  stp = 9
  xVal1 = 30
  
  x1 = 50
  xVal2 = 30
  --model.setOutput(7, 1222)
  --playNumber(123,1)
  lcd.clear()
  --lcd.drawText (x,y, "Deep:")
   --lcd.drawPixmap(x, y, "/SCRIPTS/BMP/CRSON.bmp")
   lcd.drawPixmap(x, y, "/SCRIPTS/BMP/mode_path.bmp",1)
   
    
  lcd.drawNumber(x+xVal1, y,  sensorAlt / 10 , PREC1)
  lcd.drawText (x,y+stp, "Spd:")
  lcd.drawNumber(x+xVal1, y+stp,  sensorSpd * 10, PREC1)
  lcd.drawText (x,y+stp*2, "Bat:")
  lcd.drawNumber(x+xVal1, y+stp*2,  ReceiverBatteryVoltage_current *10, PREC1)
  lcd.drawText (x,y+stp*3, "Curr:")
  lcd.drawNumber(x+xVal1, y+stp*3,  sensorCurr *10, PREC1)
  lcd.drawText (x,y+stp*4, "Sats:")
  lcd.drawNumber(x+xVal1, y+stp*4,  sensorSats)
  
  lcd.drawText (x,y+stp*5, "WP:")
--  lcd.drawNumber(x+xVal1, y+stp*5,  sensorWP )
  if re["WP"] then 
    lcd.drawNumber(x+xVal1, y+stp*5,  re["WP"]) else  lcd.drawText(x+xVal1, y+stp*5,  "-")
  end  
  
  
  
  lcd.drawText (x,y+stp*6, "GRP:")
  if re["GRP"] then 
     lcd.drawNumber(x+xVal1, y+stp*6,  re["GRP"]) else  lcd.drawText(x+xVal1, y+stp*6,  "-")
     --lcd.drawNumber(x+xVal1, y+stp*6,  sensorGRP)
  end
  
  lcd.drawText (x1,y, "Mode:")
  if re["mode"] then 
    lcd.drawNumber(x1+xVal2, y,  re["mode"]) else  lcd.drawText(x1+xVal2, y,  "-")
  end  
  
  
  lcd.drawText (x1,y+stp, "Hdg:")
  lcd.drawNumber(x1+xVal2, y+stp,  sensorHeading)
  lcd.drawText (x1,y+stp*2, "Temp")
--  lcd.drawNumber(x1+xVal2, y+stp*2,  sensorMaxAlt*100,PREC2)
  if re["temp1"] then 
    lcd.drawNumber(x1+xVal2, y+stp*2,  re["temp1"]+40) else  lcd.drawText(x1+xVal2, y+stp*2,  "-")
  end
  
  lcd.drawText (x1,y+stp*3, "Dist")
--  lcd.drawText(x1+xVal2, y+stp*3,  (getValue("Capa") ))
  if re["dist"] then 
    lcd.drawNumber(x1+xVal2, y+stp*3,  re["dist"]) else  lcd.drawText(x1+xVal2, y+stp*3,  "-")
  end

  --lcd.drawText(x1+xVal2, y+stp*3,  (getValue("Capa") ))
  lcd.drawText (x1,y+stp*4, "Crsc")
  if re["crsc"] then 
    lcd.drawNumber(x1+xVal2, y+stp*4,  re["crsc"]) else  lcd.drawText(x1+xVal2, y+stp*4,  "-")
  end
  --lcd.drawNumber(x1+xVal2, y+stp*4,  getValue("Bat%") * 100, PREC2)

  
	lcd.drawText(x1, y+stp*5, "lat:"..latitude)
	lcd.drawText(x1, y+stp*6, "lon:"..longitude)



  --lcd.drawPixmap(x1,y+stp+10,"/SCRIPTS/BMP/kmh.bmp")
  --drawArrow(118,10,sensorHeading,20)
  drawArrow(118,10, math.rad (360-sensorHeading),20)

  
end


prevmode = -1
local function go_screen(mod) 
  

  
  if not mod then
    manual_screen() 
  end
  
  if mod==0 then
   if mod~=prevmode then uniplay(44) end
    manual_screen() 
  end
  if mod==1 then
   if mod~=prevmode then uniplay(45) end
    path_screen() 
  end
  if mod==2 then
   if mod~=prevmode then uniplay(42) end
    easy_screen() 
  end
  
  prevmode = mod
  soundProcessing() 
end

local menu = false;
local function run_func(event)
 
  bg_func() -- a good way to reduce repitition
  lcd.clear()
  go_screen(re["mode"]) 
 
end




  
  



return { run=run_func, background=bg_func, init=init_func  }

